JUCE: CodeEditorComponent Class Reference

JUCE

Classes | Public Types | Public Member Functions | List of all members
CodeEditorComponent Class Reference
juce_gui_extra » code_editor

A text editor component designed specifically for source code. More...

`#include <juce_CodeEditorComponent.h>`

Inheritance diagram for CodeEditorComponent:

## Classes
struct | ColourScheme
| Defines a syntax highlighting colour scheme. More...
struct | State
| Can be used to save and restore the editor's caret position, selection state, etc. More...

## Public Types
enum | ColourIds { backgroundColourId = 0x1004500 , highlightColourId = 0x1004502 , defaultTextColourId = 0x1004503 , lineNumberBackgroundId = 0x1004504 , lineNumberTextId = 0x1004505 }
| A set of colour IDs to use to change the colour of various aspects of the editor. More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
Public Types inherited from TextInputTarget
enum | VirtualKeyboardType { textKeyboard = 0 , numericKeyboard , decimalKeyboard , urlKeyboard , emailAddressKeyboard , phoneNumberKeyboard }
| A set of possible on-screen keyboard types, for use in the getKeyboardType() method. More...

## Public Member Functions
| CodeEditorComponent (CodeDocument &document, CodeTokeniser *codeTokeniser)
| Creates an editor for a document. More...
| ~CodeEditorComponent () override
| Destructor. More...
CodeDocument & | getDocument () const noexcept
| Returns the code document that this component is editing. More...
void | loadContent (const String &newContent)
| Loads the given content into the document. More...
float | getCharWidth () const noexcept
| Returns the standard character width. More...
int | getLineHeight () const noexcept
| Returns the height of a line of text, in pixels. More...
int | getNumLinesOnScreen () const noexcept
| Returns the number of whole lines visible on the screen, This doesn't include a cut-off line that might be visible at the bottom if the component's height isn't an exact multiple of the line-height. More...
int | getFirstLineOnScreen () const noexcept
| Returns the index of the first line that's visible at the top of the editor. More...
int | getNumColumnsOnScreen () const noexcept
| Returns the number of whole columns visible on the screen. More...
CodeDocument::Position | getCaretPos () const
| Returns the current caret position. More...
int | getTotalNumChars () const override
| Returns the total number of codepoints in the string. More...
void | moveCaretTo (const CodeDocument::Position &newPos, bool selecting)
| Moves the caret. More...
Rectangle< int > | getCharacterBounds (const CodeDocument::Position &pos) const
| Returns the on-screen position of a character in the document. More...
CodeDocument::Position | getPositionAt (int x, int y) const
| Finds the character at a given on-screen position. More...
CodeDocument::Position | getSelectionStart () const
| Returns the start of the selection as a position. More...
CodeDocument::Position | getSelectionEnd () const
| Returns the end of the selection as a position. More...
void | setLineNumbersShown (bool shouldBeShown)
| Enables or disables the line-number display in the gutter. More...
int | getCaretPosition () const override
| Returns the number of characters from the beginning of the document to the caret. More...
int | getCharIndexForPoint (Point< int > point) const override
Rectangle< int > | getCaretRectangleForCharIndex (int index) const override
| Returns the bounds of the caret at a particular location in the text. More...
RectangleList< int > | getTextBounds (Range< int > textRange) const override
| Returns the bounding box for a range of text in the editor. More...
bool | moveCaretLeft (bool moveInWholeWordSteps, bool selecting)
bool | moveCaretRight (bool moveInWholeWordSteps, bool selecting)
bool | moveCaretUp (bool selecting)
bool | moveCaretDown (bool selecting)
bool | scrollDown ()
bool | scrollUp ()
bool | pageUp (bool selecting)
bool | pageDown (bool selecting)
bool | moveCaretToTop (bool selecting)
bool | moveCaretToStartOfLine (bool selecting)
bool | moveCaretToEnd (bool selecting)
bool | moveCaretToEndOfLine (bool selecting)
bool | deleteBackwards (bool moveInWholeWordSteps)
bool | deleteForwards (bool moveInWholeWordSteps)
bool | deleteWhitespaceBackwardsToTabStop ()
virtual bool | copyToClipboard ()
virtual bool | cutToClipboard ()
virtual bool | pasteFromClipboard ()
bool | undo ()
bool | redo ()
void | selectRegion (const CodeDocument::Position &start, const CodeDocument::Position &end)
bool | selectAll ()
void | deselectAll ()
void | scrollToLine (int newFirstLineOnScreen)
void | scrollBy (int deltaLines)
void | scrollToColumn (int newFirstColumnOnScreen)
void | scrollToKeepCaretOnScreen ()
void | scrollToKeepLinesOnScreen (Range< int > linesToShow)
void | insertTextAtCaret (const String &textToInsert) override
| Inserts some text, overwriting the selected text region, if there is one. More...
void | insertTabAtCaret ()
void | indentSelection ()
void | unindentSelection ()
Range< int > | getHighlightedRegion () const override
| Returns the extents of the selected text region, or an empty range if nothing is selected,. More...
bool | isHighlightActive () const noexcept
void | setHighlightedRegion (const Range< int > &newRange) override
| Sets the currently-selected text region. More...
String | getTextInRange (const Range< int > &range) const override
| Returns a specified sub-section of the text. More...
void | setTabSize (int numSpacesPerTab, bool insertSpacesInsteadOfTabCharacters)
| Changes the current tab settings. More...
int | getTabSize () const noexcept
| Returns the current number of spaces per tab. More...
bool | areSpacesInsertedForTabs () const
| Returns true if the tab key will insert spaces instead of actual tab characters. More...
String | getTabString (int numSpaces) const
| Returns a string containing spaces or tab characters to generate the given number of spaces. More...
void | setFont (const Font &newFont)
| Changes the font. More...
const Font & | getFont () const noexcept
| Returns the font that the editor is using. More...
void | setReadOnly (bool shouldBeReadOnly) noexcept
| Makes the editor read-only. More...
bool | isReadOnly () const noexcept
| Returns true if the editor is set to be read-only. More...
void | setColourScheme (const ColourScheme &scheme)
| Changes the syntax highlighting scheme. More...
const ColourScheme & | getColourScheme () const noexcept
| Returns the current syntax highlighting colour scheme. More...
Colour | getColourForTokenType (int tokenType) const
| Returns one the syntax highlighting colour for the given token. More...
void | retokenise (int startIndex, int endIndex)
| Rebuilds the syntax highlighting for a section of text. More...
void | setScrollbarThickness (int thickness)
| Changes the size of the scrollbars. More...
int | getScrollbarThickness () const noexcept
| Returns the thickness of the scrollbars. More...
virtual void | handleReturnKey ()
| Called when the return key is pressed - this can be overridden for custom behaviour. More...
virtual void | handleTabKey ()
| Called when the tab key is pressed - this can be overridden for custom behaviour. More...
virtual void | handleEscapeKey ()
| Called when the escape key is pressed - this can be overridden for custom behaviour. More...
virtual void | editorViewportPositionChanged ()
| Called when the view position is scrolled horizontally or vertically. More...
virtual void | caretPositionMoved ()
| Called when the caret position moves. More...
virtual void | addPopupMenuItems (PopupMenu &menuToAddTo, const MouseEvent *mouseClickEvent)
| This adds the items to the popup menu. More...
virtual void | performPopupMenuAction (int menuItemID)
| This is called to perform one of the items that was shown on the popup menu. More...
void | setCommandManager (ApplicationCommandManager *newManager) noexcept
| Specifies a command-manager which the editor will notify whenever the state of any of its commands changes. More...
void | paint (Graphics &) override
void | resized () override
bool | keyPressed (const KeyPress &) override
void | mouseDown (const MouseEvent &) override
void | mouseDrag (const MouseEvent &) override
void | mouseUp (const MouseEvent &) override
void | mouseDoubleClick (const MouseEvent &) override
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
void | focusGained (FocusChangeType) override
void | focusLost (FocusChangeType) override
bool | isTextInputActive () const override
void | setTemporaryUnderlining (const Array< Range< int > > &) override
ApplicationCommandTarget * | getNextCommandTarget () override
void | getAllCommands (Array< CommandID > &) override
void | getCommandInfo (CommandID, ApplicationCommandInfo &) override
bool | perform (const InvocationInfo &) override
void | lookAndFeelChanged () override
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component. More...
| ~Component () override
| Destructor. More...
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time. More...
String | getName () const noexcept
| Returns the name of this component. More...
virtual void | setName (const String &newName)
| Sets the name of this component. More...
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID(). More...
void | setComponentID (const String &newID)
| Sets the component's ID string. More...
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible. More...
bool | isVisible () const noexcept
| Tests whether the component is visible or not. More...
virtual void | visibilityChanged ()
| Called when this component's visibility changes. More...
bool | isShowing () const
| Tests whether this component and all its parents are visible. More...
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop. More...
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it. More...
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop. More...
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component. More...
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window. More...
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised. More...
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop. More...
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings. More...
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings. More...
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component. More...
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings. More...
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings. More...
int | getX () const noexcept
| Returns the x coordinate of the component's left edge. More...
int | getY () const noexcept
| Returns the y coordinate of the top of this component. More...
int | getWidth () const noexcept
| Returns the component's width in pixels. More...
int | getHeight () const noexcept
| Returns the component's height in pixels. More...
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge. More...
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point. More...
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component. More...
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box. More...
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin. More...
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers. More...
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin. More...
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin. More...
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left. More...
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left. More...
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position. More...
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position. More...
void | setTopRightPosition (int x, int y)
| Moves the component to a new position. More...
void | setSize (int newWidth, int newHeight)
| Changes the size of the component. More...
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size. More...
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size. More...
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it. More...
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged. More...
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre. More...
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre. More...
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre. More...
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent. More...
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component. More...
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component. More...
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component. More...
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width. More...
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height. More...
int | getParentWidth () const noexcept
| Returns the width of the component's parent. More...
int | getParentHeight () const noexcept
| Returns the height of the component's parent. More...
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component. More...
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains. More...
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index. More...
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components. More...
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components. More...
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID. More...
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one. More...
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one. More...
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID. More...
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components. More...
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index. More...
void | removeAllChildren ()
| Removes all this component's children. More...
void | deleteAllChildren ()
| Removes and deletes all of this component's children. More...
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside. More...
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class. More...
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents. More...
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children. More...
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed. More...
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes. More...
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component. More...
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method. More...
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags. More...
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one. More...
void | repaint ()
| Marks the whole component as needing to be redrawn. More...
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn. More...
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn. More...
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing. More...
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component. More...
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context. More...
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted. More...
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted. More...
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance. More...
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect. More...
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component. More...
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component. More...
void | sendLookAndFeelChange ()
| Calls the lookAndFeelChanged() method in this component and all its children. More...
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent. More...
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent. More...
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked. More...
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on. More...
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component. More...
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified. More...
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports. More...
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container. More...
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container. More...
Component * | findFocusContainer () const
| Returns the focus container for this component. More...
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component. More...
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not. More...
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus. More...
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus. More...
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus(). More...
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component. More...
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component. More...
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus. More...
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings. More...
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component. More...
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component. More...
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus. More...
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline. More...
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled. More...
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component. More...
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled. More...
float | getAlpha () const noexcept
| Returns the component's current transparency level. More...
void | setAlpha (float newAlpha)
| Changes the transparency of this component. More...
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component. More...
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component. More...
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component. More...
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated. More...
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children. More...
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component. More...
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component. More...
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component. More...
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used. More...
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component. More...
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component. More...
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener. More...
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives. More...
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener. More...
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released. More...
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released. More...
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component. More...
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component. More...
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component. More...
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component. More...
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component. More...
virtual void | moved ()
| Called when this component's position has been changed. More...
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized. More...
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized. More...
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings. More...
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position. More...
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener. More...
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component. More...
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage(). More...
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates. More...
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state. More...
void | exitModalState (int returnValue)
| Ends a component's modal state. More...
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one. More...
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages. More...
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events. More...
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component. More...
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component. More...
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component. More...
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose. More...
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it. More...
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method. More...
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component. More...
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method. More...
void * | getWindowHandle () const
| Returns the underlying native window handle for this component. More...
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component. More...
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component. More...
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting. More...
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage(). More...
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled. More...
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag. More...
String | getTitle () const noexcept
| Returns the title text for this component. More...
void | setTitle (const String &newTitle)
| Sets the title for this component. More...
String | getDescription () const noexcept
| Returns the description for this component. More...
void | setDescription (const String &newDescription)
| Sets the description for this component. More...
String | getHelpText () const noexcept
| Returns the help text for this component. More...
void | setHelpText (const String &newHelpText)
| Sets the help text for this component. More...
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients. More...
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients. More...
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible. More...
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component. More...
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor. More...
Public Member Functions inherited from ApplicationCommandTarget
| ApplicationCommandTarget ()
| Creates a command target. More...
virtual | ~ApplicationCommandTarget ()
| Destructor. More...
bool | invoke (const InvocationInfo &invocationInfo, const bool asynchronously)
| Makes this target invoke a command. More...
bool | invokeDirectly (const CommandID commandID, const bool asynchronously)
| Invokes a given command directly on this target. More...
ApplicationCommandTarget * | getTargetForCommand (const CommandID commandID)
| Searches this target and all subsequent ones for the first one that can handle the specified command. More...
bool | isCommandActive (const CommandID commandID)
| Checks whether this command can currently be performed by this target. More...
ApplicationCommandTarget * | findFirstTargetParentComponent ()
| If this object is a Component, this method will search upwards in its current UI hierarchy for the next parent component that implements the ApplicationCommandTarget class. More...
Public Member Functions inherited from TextInputTarget
| TextInputTarget ()=default
virtual | ~TextInputTarget ()=default
| Destructor. More...
Rectangle< int > | getCaretRectangle () const
| Returns the position of the caret, relative to the component's origin. More...
virtual VirtualKeyboardType | getKeyboardType ()
| Returns the target's preference for the type of keyboard that would be most appropriate. More...

## Additional Inherited Members
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor. More...
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus. More...
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it. More...
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation. More...
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down. More...
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state. More...
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal. More...

## Detailed Description

A text editor component designed specifically for source code.

This is designed to handle syntax highlighting and fast editing of very large files.

## Member Enumeration Documentation

## ◆ ColourIds

enum CodeEditorComponent::ColourIds

A set of colour IDs to use to change the colour of various aspects of the editor.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | A colour to use to fill the editor's background.
highlightColourId | The colour to use for the highlighted background under selected text.
defaultTextColourId | The colour to use for text when no syntax colouring is enabled.
lineNumberBackgroundId | The colour to use for filling the background of the line-number gutter.
lineNumberTextId | The colour to use for drawing the line numbers.

## Constructor & Destructor Documentation

## ◆ CodeEditorComponent()

CodeEditorComponent::CodeEditorComponent | ( | CodeDocument & | document,
|  | CodeTokeniser * | codeTokeniser
| ) |  |

Creates an editor for a document.

The tokeniser object is optional - pass nullptr to disable syntax highlighting. The object that you pass in is not owned or deleted by the editor - you must make sure that it doesn't get deleted while this component is still using it.

See also
  CodeDocument

## ◆ ~CodeEditorComponent()

CodeEditorComponent::~CodeEditorComponent | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ getDocument()

CodeDocument & CodeEditorComponent::getDocument | ( |  | ) | const
| noexcept

Returns the code document that this component is editing.

## ◆ loadContent()

void CodeEditorComponent::loadContent | ( | const String & | newContent | ) |

Loads the given content into the document.

This will completely reset the CodeDocument object, clear its undo history, and fill it with this text.

## ◆ getCharWidth()

float CodeEditorComponent::getCharWidth | ( |  | ) | const
| noexcept

Returns the standard character width.

## ◆ getLineHeight()

int CodeEditorComponent::getLineHeight | ( |  | ) | const
| noexcept

Returns the height of a line of text, in pixels.

## ◆ getNumLinesOnScreen()

int CodeEditorComponent::getNumLinesOnScreen | ( |  | ) | const
| noexcept

Returns the number of whole lines visible on the screen, This doesn't include a cut-off line that might be visible at the bottom if the component's height isn't an exact multiple of the line-height.

## ◆ getFirstLineOnScreen()

int CodeEditorComponent::getFirstLineOnScreen | ( |  | ) | const
| noexcept

Returns the index of the first line that's visible at the top of the editor.

## ◆ getNumColumnsOnScreen()

int CodeEditorComponent::getNumColumnsOnScreen | ( |  | ) | const
| noexcept

Returns the number of whole columns visible on the screen.

This doesn't include any cut-off columns at the right-hand edge.

## ◆ getCaretPos()

CodeDocument::Position CodeEditorComponent::getCaretPos | ( |  | ) | const

Returns the current caret position.

## ◆ getTotalNumChars()

int CodeEditorComponent::getTotalNumChars | ( |  | ) | const
| overridevirtual

Returns the total number of codepoints in the string.

Implements TextInputTarget.

## ◆ moveCaretTo()

void CodeEditorComponent::moveCaretTo | ( | const CodeDocument::Position & | newPos,
|  | bool | selecting
| ) |  |

Moves the caret.

If selecting is true, the section of the document between the current caret position and the new one will become selected. If false, any currently selected region will be deselected.

## ◆ getCharacterBounds()

Rectangle< int > CodeEditorComponent::getCharacterBounds | ( | const CodeDocument::Position & | pos | ) | const

Returns the on-screen position of a character in the document.

The rectangle returned is relative to this component's top-left origin.

## ◆ getPositionAt()

CodeDocument::Position CodeEditorComponent::getPositionAt | ( | int | x,
|  | int | y
| ) |  | const

Finds the character at a given on-screen position.

The coordinates are relative to this component's top-left origin.

## ◆ getSelectionStart()

CodeDocument::Position CodeEditorComponent::getSelectionStart | ( |  | ) | const

Returns the start of the selection as a position.

## ◆ getSelectionEnd()

CodeDocument::Position CodeEditorComponent::getSelectionEnd | ( |  | ) | const

Returns the end of the selection as a position.

## ◆ setLineNumbersShown()

void CodeEditorComponent::setLineNumbersShown | ( | bool | shouldBeShown | ) |

Enables or disables the line-number display in the gutter.

## ◆ getCaretPosition()

int CodeEditorComponent::getCaretPosition | ( |  | ) | const
| overridevirtual

Returns the number of characters from the beginning of the document to the caret.

Implements TextInputTarget.

## ◆ getCharIndexForPoint()

int CodeEditorComponent::getCharIndexForPoint | ( | Point< int > | point | ) | const
| overridevirtual

See also
  getPositionAt

Implements TextInputTarget.

## ◆ getCaretRectangleForCharIndex()

Rectangle< int > CodeEditorComponent::getCaretRectangleForCharIndex | ( | int | index | ) | const
| overridevirtual

Returns the bounds of the caret at a particular location in the text.

Implements TextInputTarget.

References gl::index.

## ◆ getTextBounds()

RectangleList< int > CodeEditorComponent::getTextBounds | ( | Range< int > | textRange | ) | const
| overridevirtual

Returns the bounding box for a range of text in the editor.

As the range may span multiple lines, this method returns a RectangleList.

The bounds are relative to the component's top-left and may extend beyond the bounds of the component if the text is long and word wrapping is disabled.

Implements TextInputTarget.

## ◆ moveCaretLeft()

bool CodeEditorComponent::moveCaretLeft | ( | bool | moveInWholeWordSteps,
|  | bool | selecting
| ) |  |

## ◆ moveCaretRight()

bool CodeEditorComponent::moveCaretRight | ( | bool | moveInWholeWordSteps,
|  | bool | selecting
| ) |  |

## ◆ moveCaretUp()

bool CodeEditorComponent::moveCaretUp | ( | bool | selecting | ) |

## ◆ moveCaretDown()

bool CodeEditorComponent::moveCaretDown | ( | bool | selecting | ) |

## ◆ scrollDown()

bool CodeEditorComponent::scrollDown | ( |  | ) |

## ◆ scrollUp()

bool CodeEditorComponent::scrollUp | ( |  | ) |

## ◆ pageUp()

bool CodeEditorComponent::pageUp | ( | bool | selecting | ) |

## ◆ pageDown()

bool CodeEditorComponent::pageDown | ( | bool | selecting | ) |

## ◆ moveCaretToTop()

bool CodeEditorComponent::moveCaretToTop | ( | bool | selecting | ) |

## ◆ moveCaretToStartOfLine()

bool CodeEditorComponent::moveCaretToStartOfLine | ( | bool | selecting | ) |

## ◆ moveCaretToEnd()

bool CodeEditorComponent::moveCaretToEnd | ( | bool | selecting | ) |

## ◆ moveCaretToEndOfLine()

bool CodeEditorComponent::moveCaretToEndOfLine | ( | bool | selecting | ) |

## ◆ deleteBackwards()

bool CodeEditorComponent::deleteBackwards | ( | bool | moveInWholeWordSteps | ) |

## ◆ deleteForwards()

bool CodeEditorComponent::deleteForwards | ( | bool | moveInWholeWordSteps | ) |

## ◆ deleteWhitespaceBackwardsToTabStop()

bool CodeEditorComponent::deleteWhitespaceBackwardsToTabStop | ( |  | ) |

## ◆ copyToClipboard()

virtual bool CodeEditorComponent::copyToClipboard | ( |  | ) |
| virtual

## ◆ cutToClipboard()

virtual bool CodeEditorComponent::cutToClipboard | ( |  | ) |
| virtual

## ◆ pasteFromClipboard()

virtual bool CodeEditorComponent::pasteFromClipboard | ( |  | ) |
| virtual

## ◆ undo()

bool CodeEditorComponent::undo | ( |  | ) |

## ◆ redo()

bool CodeEditorComponent::redo | ( |  | ) |

## ◆ selectRegion()

void CodeEditorComponent::selectRegion | ( | const CodeDocument::Position & | start,
|  | const CodeDocument::Position & | end
| ) |  |

## ◆ selectAll()

bool CodeEditorComponent::selectAll | ( |  | ) |

## ◆ deselectAll()

void CodeEditorComponent::deselectAll | ( |  | ) |

## ◆ scrollToLine()

void CodeEditorComponent::scrollToLine | ( | int | newFirstLineOnScreen | ) |

## ◆ scrollBy()

void CodeEditorComponent::scrollBy | ( | int | deltaLines | ) |

## ◆ scrollToColumn()

void CodeEditorComponent::scrollToColumn | ( | int | newFirstColumnOnScreen | ) |

## ◆ scrollToKeepCaretOnScreen()

void CodeEditorComponent::scrollToKeepCaretOnScreen | ( |  | ) |

## ◆ scrollToKeepLinesOnScreen()

void CodeEditorComponent::scrollToKeepLinesOnScreen | ( | Range< int > | linesToShow | ) |

## ◆ insertTextAtCaret()

void CodeEditorComponent::insertTextAtCaret | ( | const String & | textToInsert | ) |
| overridevirtual

Inserts some text, overwriting the selected text region, if there is one.

Implements TextInputTarget.

## ◆ insertTabAtCaret()

void CodeEditorComponent::insertTabAtCaret | ( |  | ) |

## ◆ indentSelection()

void CodeEditorComponent::indentSelection | ( |  | ) |

## ◆ unindentSelection()

void CodeEditorComponent::unindentSelection | ( |  | ) |

## ◆ getHighlightedRegion()

Range< int > CodeEditorComponent::getHighlightedRegion | ( |  | ) | const
| overridevirtual

Returns the extents of the selected text region, or an empty range if nothing is selected,.

Implements TextInputTarget.

## ◆ isHighlightActive()

bool CodeEditorComponent::isHighlightActive | ( |  | ) | const
| noexcept

## ◆ setHighlightedRegion()

void CodeEditorComponent::setHighlightedRegion | ( | const Range< int > & | newRange | ) |
| overridevirtual

Sets the currently-selected text region.

Implements TextInputTarget.

## ◆ getTextInRange()

String CodeEditorComponent::getTextInRange | ( | const Range< int > & | range | ) | const
| overridevirtual

Returns a specified sub-section of the text.

Implements TextInputTarget.

## ◆ setTabSize()

void CodeEditorComponent::setTabSize | ( | int | numSpacesPerTab,
|  | bool | insertSpacesInsteadOfTabCharacters
| ) |  |

Changes the current tab settings.

This lets you change the tab size and whether pressing the tab key inserts a tab character, or its equivalent number of spaces.

## ◆ getTabSize()

int CodeEditorComponent::getTabSize | ( |  | ) | const
| noexcept

Returns the current number of spaces per tab.

See also
  setTabSize

## ◆ areSpacesInsertedForTabs()

bool CodeEditorComponent::areSpacesInsertedForTabs | ( |  | ) | const

Returns true if the tab key will insert spaces instead of actual tab characters.

See also
  setTabSize

## ◆ getTabString()

String CodeEditorComponent::getTabString | ( | int | numSpaces | ) | const

Returns a string containing spaces or tab characters to generate the given number of spaces.

## ◆ setFont()

void CodeEditorComponent::setFont | ( | const Font & | newFont | ) |

Changes the font.

Make sure you only use a fixed-width font, or this component will look pretty nasty!

## ◆ getFont()

const Font & CodeEditorComponent::getFont | ( |  | ) | const
| noexcept

Returns the font that the editor is using.

## ◆ setReadOnly()

void CodeEditorComponent::setReadOnly | ( | bool | shouldBeReadOnly | ) |
| noexcept

Makes the editor read-only.

## ◆ isReadOnly()

bool CodeEditorComponent::isReadOnly | ( |  | ) | const
| noexcept

Returns true if the editor is set to be read-only.

## ◆ setColourScheme()

void CodeEditorComponent::setColourScheme | ( | const ColourScheme & | scheme | ) |

Changes the syntax highlighting scheme.

The token type values are dependent on the tokeniser being used - use CodeTokeniser::getTokenTypes() to get a list of the token types.

See also
  getColourForTokenType

## ◆ getColourScheme()

const ColourScheme & CodeEditorComponent::getColourScheme | ( |  | ) | const
| noexcept

Returns the current syntax highlighting colour scheme.

## ◆ getColourForTokenType()

Colour CodeEditorComponent::getColourForTokenType | ( | int | tokenType | ) | const

Returns one the syntax highlighting colour for the given token.

The token type values are dependent on the tokeniser being used.

See also
  setColourScheme

## ◆ retokenise()

void CodeEditorComponent::retokenise | ( | int | startIndex,
|  | int | endIndex
| ) |  |

Rebuilds the syntax highlighting for a section of text.

This happens automatically any time the CodeDocument is edited, but this method lets you change text colours even when the CodeDocument hasn't changed.

For example, you could use this to highlight tokens as the cursor moves. To do so you'll need to tell your custom CodeTokeniser where the token you want to highlight is, and make it return a special type of token. Then you should call this method supplying the range of the highlighted text.

See also
  CodeTokeniser

## ◆ setScrollbarThickness()

void CodeEditorComponent::setScrollbarThickness | ( | int | thickness | ) |

Changes the size of the scrollbars.

## ◆ getScrollbarThickness()

int CodeEditorComponent::getScrollbarThickness | ( |  | ) | const
| noexcept

Returns the thickness of the scrollbars.

## ◆ handleReturnKey()

virtual void CodeEditorComponent::handleReturnKey | ( |  | ) |
| virtual

Called when the return key is pressed - this can be overridden for custom behaviour.

## ◆ handleTabKey()

virtual void CodeEditorComponent::handleTabKey | ( |  | ) |
| virtual

Called when the tab key is pressed - this can be overridden for custom behaviour.

## ◆ handleEscapeKey()

virtual void CodeEditorComponent::handleEscapeKey | ( |  | ) |
| virtual

Called when the escape key is pressed - this can be overridden for custom behaviour.

## ◆ editorViewportPositionChanged()

virtual void CodeEditorComponent::editorViewportPositionChanged | ( |  | ) |
| virtual

Called when the view position is scrolled horizontally or vertically.

## ◆ caretPositionMoved()

virtual void CodeEditorComponent::caretPositionMoved | ( |  | ) |
| virtual

Called when the caret position moves.

## ◆ addPopupMenuItems()

virtual void CodeEditorComponent::addPopupMenuItems | ( | PopupMenu & | menuToAddTo,
|  | const MouseEvent * | mouseClickEvent
| ) |  |
| virtual

This adds the items to the popup menu.

By default it adds the cut/copy/paste items, but you can override this if you need to replace these with your own items.

If you want to add your own items to the existing ones, you can override this, call the base class's addPopupMenuItems() method, then append your own items.

When the menu has been shown, performPopupMenuAction() will be called to perform the item that the user has chosen.

If this was triggered by a mouse-click, the mouseClickEvent parameter will be a pointer to the info about it, or may be null if the menu is being triggered by some other means.

See also
  performPopupMenuAction, setPopupMenuEnabled, isPopupMenuEnabled

## ◆ performPopupMenuAction()

virtual void CodeEditorComponent::performPopupMenuAction | ( | int | menuItemID | ) |
| virtual

This is called to perform one of the items that was shown on the popup menu.

If you've overridden addPopupMenuItems(), you should also override this to perform the actions that you've added.

If you've overridden addPopupMenuItems() but have still left the default items on the menu, remember to call the superclass's performPopupMenuAction() so that it can perform the default actions if that's what the user clicked on.

See also
  addPopupMenuItems, setPopupMenuEnabled, isPopupMenuEnabled

## ◆ setCommandManager()

void CodeEditorComponent::setCommandManager | ( | ApplicationCommandManager * | newManager | ) |
| noexcept

Specifies a command-manager which the editor will notify whenever the state of any of its commands changes.

If you're making use of the editor's ApplicationCommandTarget interface, then you should also use this to tell it which command manager it should use. Make sure that the manager does not go out of scope while the editor is using it. You can pass a nullptr here to disable this.

## ◆ paint()

void CodeEditorComponent::paint | ( | Graphics & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ resized()

void CodeEditorComponent::resized | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ keyPressed()

bool CodeEditorComponent::keyPressed | ( | const KeyPress & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseDown()

void CodeEditorComponent::mouseDown | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseDrag()

void CodeEditorComponent::mouseDrag | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseUp()

void CodeEditorComponent::mouseUp | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseDoubleClick()

void CodeEditorComponent::mouseDoubleClick | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseWheelMove()

void CodeEditorComponent::mouseWheelMove | ( | const MouseEvent & | ,
|  | const MouseWheelDetails & |
| ) |  |
| overridevirtual

Reimplemented from Component.

## ◆ focusGained()

void CodeEditorComponent::focusGained | ( | FocusChangeType |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ focusLost()

void CodeEditorComponent::focusLost | ( | FocusChangeType |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ isTextInputActive()

bool CodeEditorComponent::isTextInputActive | ( |  | ) | const
| overridevirtual

Implements TextInputTarget.

## ◆ setTemporaryUnderlining()

void CodeEditorComponent::setTemporaryUnderlining | ( | const Array< Range< int > > & |  | ) |
| overridevirtual

Implements TextInputTarget.

## ◆ getNextCommandTarget()

ApplicationCommandTarget * CodeEditorComponent::getNextCommandTarget | ( |  | ) |
| overridevirtual

Implements ApplicationCommandTarget.

## ◆ getAllCommands()

void CodeEditorComponent::getAllCommands | ( | Array< CommandID > & |  | ) |
| overridevirtual

Implements ApplicationCommandTarget.

## ◆ getCommandInfo()

void CodeEditorComponent::getCommandInfo | ( | CommandID | ,
|  | ApplicationCommandInfo & |
| ) |  |
| overridevirtual

Implements ApplicationCommandTarget.

## ◆ perform()

bool CodeEditorComponent::perform | ( | const InvocationInfo & |  | ) |
| overridevirtual

Implements ApplicationCommandTarget.

## ◆ lookAndFeelChanged()

void CodeEditorComponent::lookAndFeelChanged | ( |  | ) |
| overridevirtual

Reimplemented from Component.

The documentation for this class was generated from the following file:

- juce_CodeEditorComponent.h